<template>
  <div class="tableDisplay">
    <div class="header">
      <el-button style="float:left;" size="small" type="default" icon="el-icon-back" @click="goBack"></el-button>
      <span :title="`${name} - ${code}`" class="details-title"><b>{{ name }} - {{ code }}</b></span>
    </div>
    <div class="content">
      <el-scrollbar style="height:100%;">
        <div class="content-scrollbar">
          <div class="content-left">
            <div class="content-keyPoint">
              <exhibitionCrux :exhibitionCrux="exhibitionCrux" :type="type" @cruxSuccess="cruxSuccess"/>
            </div>
            <div class="content-showType">
              <selectRadio
                :selectRadio="selectRadio"
                @changeRadio="changeRadio"
              />
            </div>
            <div class="content-point">
              <div class="content-point-left">
                <exhibitionBaseInformation :exhibitionBaseInformation="exhibitionBaseInformation"/>
              </div>
              <div class="content-point-right">
                <exhibitionEnergy :exhibitionEnergy="exhibitionEnergy"/>
              </div>
            </div>
          </div>
          <div class="content-right">
            <div class="content-repair">
              <exhibitionMaintain :exhibitionMaintain="exhibitionMaintain"/>
            </div>
            <div class="content-media">
              <exhibitionImage :exhibitionImage="exhibitionImage" v-show="isShowImage"/>
              <exhibitionVideo :exhibitionVideo="exhibitionVideo" v-show="isShowVideo"/>
              <exhibitionFile :exhibitionFile="exhibitionFile" v-show="isShowFile"/>
            </div>
          </div>
        </div>
      </el-scrollbar>
    </div>
    <div class="footer">
      <el-button-group style="float:right;margin:8px 10px 0 0">
        <el-button
          :disabled="list.findIndex(item => item.value == id) == 0"
          @click="handleClickPrev"
          size="mini"
          icon="el-icon-arrow-left">
          上一页
        </el-button>
        <el-select size="mini" style="float:left;margin:0 10px;" v-model="id" @change="handleChangeExample"
                   placeholder="请选择">
          <el-option
            v-for="item in list"
            :key="item.value"
            :label="item.label"
            :value="item.value">
          </el-option>
        </el-select>
        <el-button
          :disabled="list.findIndex(item => item.value == id) == list.length-1"
          @click="handleClickNext"
          size="mini">
          下一页
          <i class="el-icon-arrow-right el-icon--right"></i>
        </el-button>
      </el-button-group>
    </div>
  </div>
</template>

<script>
import exhibitionBaseInformation from "@/components/ledger/details/detail/exhibitionBaseInformation";
import exhibitionFile from "@/components/ledger/details/detail/exhibitionFile";
import exhibitionImage from "@/components/ledger/details/detail/exhibitionImage";
import exhibitionVideo from "@/components/ledger/details/detail/exhibitionVideo";
import exhibitionCrux from "@/components/ledger/details/detail/exhibitionCrux";
import exhibitionEnergy from "@/components/ledger/details/detail/exhibitionEnergy";
import exhibitionMaintain from "@/components/ledger/details/detail/exhibitionMaintain";
import selectRadio from "@/components/ledger/details/detail/selectRadio";
import tools from "@/utils/scan/tools"
import { BeatchQueryParam } from "@/api/scan/request";
import { getDataDictionary } from "@/api/dict";
import { queryEquip } from "@/api/object/equip"
import { mapGetters } from "vuex";

export default {
  name: "deviceDetails",
  components: {
    exhibitionBaseInformation,
    exhibitionFile,
    exhibitionVideo,
    exhibitionImage,
    exhibitionMaintain,
    selectRadio,
    exhibitionCrux,
    exhibitionEnergy
  },
  created() {
    this.id = this.$route.query.equipId;
    this.name = this.$route.query.equipName;
    this.code = this.$route.query.equipCode;
    this.type = this.$route.query.type;
    this.list = this.$route.query.data;
    this.getData();
  },
  computed: {
    ...mapGetters("layout", ["projectId", "secret", "userId"])
  },
  data() {
    return {
      id: '', //当前设备id
      name: '', //当前设备本地名称
      code: '', //当前设备的本地编码
      type: '', //设备类型
      list: [], //设备列表
      pointData: [], //信息点数据
      exampleData: {}, //实例数据
      currentRadio: '1',//当前选中的select
      criterias: [], //动态参数
      criteriasArray: [],
      selectRadio: {
        information: '设备信息点',
        initRadio: '1',
        radioList: [
          {
            value: '显示需采集信息点',
            label: '1'
          },
          {
            value: '显示有值信息点',
            label: '2'
          },
          {
            value: '显示全部信息点',
            label: '3'
          }
        ]
      },
      exhibitionBaseInformation: {
        information: {}
      },
      exhibitionEnergy: {
        title: '能耗信息',
        firstName: '',
        dynamic: [],
        list: {}
      },
      exhibitionMaintain: {
        title: '维修/维保记录'
      },
      exhibitionFile: {
        title: '文件',
        list: {}
      },
      exhibitionCrux: {
        title: '关键信息点：',
        cruxArray: [],
        allMessage: [],//全部信息点
      },
      exhibitionImage: {
        title: '图片',
        list: {},
        arr: []
      },
      exhibitionVideo: {
        title: '视频',
        list: []
      },
      instance: {},//实例信息处理
      isShowImage: false,
      isShowVideo: false,
      isShowFile: false,
    }
  },
  methods: {
    deepCopy(obj) {
      return JSON.parse(JSON.stringify(obj))
    },
    cruxSuccess() {
      this.getData()
    },
    // 获取表头和实例数据（动态数据在组件中获取，在此格式化请求参数）
    getData() {
      let params1 = {
        orders: "sort asc",
        pageNumber: 1,
        pageSize: 1000,
        type: this.type
      }, params2 = {
        filters: `id='${this.id}'`,
      };
      let promise1 = new Promise((resolve, reject) => {
        getDataDictionary(params1, res => {
          resolve(res)
        })
      })
      let promise2 = new Promise((resolve, reject) => {
        queryEquip(params2, res => {
          resolve(res)
        })
      })
      // 数据初始化
      this.exhibitionEnergy.dynamic = [];
      this.criterias = [];

      Promise.all([promise1, promise2]).then(values => {
        this.pointData = values[0].content;
        this.exampleData = values[1].content[0];
        this.name = this.exampleData.localName ? this.exampleData.localName : this.exampleData.name ? this.exampleData.name : '';
        this.code = this.exampleData.localId ? this.exampleData.localId : '';
        let obj = this.deepCopy(values[1].content[0]);
        obj = tools.flattenKeys(obj);
        for (let key in obj) {           //删除对象中数组为空的项
          if (Array.isArray(obj[key]) && !obj[key].length) {
            delete obj[key]
          }
        }
        this.instance = obj;
        this.pointData.forEach(item => {
          if (item.inputMode == "L" || item.inputMode == "L1" || item.inputMode == "L2" || item.inputMode == "M") {
            let cur = tools.dataForKey(this.exampleData, item.path);
            if (cur) {
              this.criterias.push({
                objectId: this.exampleData.id,
                infoCode: item.code
              })
            }
          }
        })
        let params = { //获取动态参数
          groupCode: "WD",
          appId: "datacenter",
          projectId: this.projectId,
          data: []
        }
        params.data = this.criterias
        if (this.criterias.length) {
          BeatchQueryParam(params, res => {
            this.criteriasArray = res.data;
            res.data.length && res.data.map(child => {
              this.pointData.map(head => {
                if (head.code == child.infoCode) {
                  if (head.dataSource) {
                    head.dataSource.forEach(i => {
                      if (i.code == child.data) {
                        this.$set(head, 'data', i.name)
                      }
                    })
                  } else {
                    this.$set(head, 'data', child.data)
                  }
                  // this.$set(head, 'svalue', child.value)
                  this.$set(head, 'svalue', child.infoValue)
                  // this.$set(head, 'receivetime', child.receivetime)
                  this.$set(head, 'receivetime', child.time)
                  this.$set(head, 'error', child.error)
                }
                return head
              })
            })
            this.handleRadios(this.currentRadio);
            this.handleEnclosure() //处理图片视频文件信息
          })
        } else {
          this.handleRadios(this.currentRadio);
          this.handleEnclosure() //处理图片视频文件信息
        }

      })
    },
    handleEnclosure() {
      //图片文件处理，脱离radio控制
      let isList = this.pointData
      let isArr = []
      isList.map(j => {
        if (this.instance.hasOwnProperty(j.path)) {
          j.value = this.instance[j.path]
          return j
        }
      })
      isArr = isList.filter(k => k.value)
      this.handlePicList(isArr)
      this.handleFileList(isArr)
    },
    handleRadios(val) { //判断radio的值显示关键信息，基本信息，图片，文件
      let arr = []
      //关键信息点
      this.exhibitionCrux.cruxArray = this.pointData.filter(i => i.keyWord)
      this.exhibitionCrux.cruxArray.map(i => {
        if (this.instance.hasOwnProperty(i.path)) {
          return {
            ...i,
            value: this.instance[i.path]
          }
        }
      })

      if (val == 1) { //需采集信息
        arr = this.pointData.filter(i => i.visible)
        // //  图片和的处理
        // this.handlePicList(arr)
        // //  文件处理
        // this.handleFileList(arr)

      } else if (val == 2) { //有值信息点
        let list = this.pointData
        list.map(j => {
          if (this.instance.hasOwnProperty(j.path)) {
            return {
              ...j,
              value: this.instance[j.path]
            }


          }
        })
        arr = list.filter(k => k.value)
        // this.handlePicList(arr, 2)
        // this.handleFileList(arr, 2)

      } else { //全部信息点
        arr = this.pointData
        // this.handlePicList(arr)
        // this.handleFileList(arr)
      }
      this.displayData(arr)
    },
    handlePicList(arr) {
      let picObject = {}
      //处理数据格式
      arr.map(i => {
        if (i.inputMode == 'F2') {
          switch (i.path) {
            case 'infos.drawing':
            case 'infos.installPic':
            case 'infos.installDrawing':
            case 'infos.nameplate':
            case 'infos.pic':
            case 'pic' :
              if (this.instance.hasOwnProperty(i.path)) {
                i.PicList = this.instance[i.path]
              }
              if (picObject[i.name]) {
              } else {
                picObject[i.name] = []
              }
              picObject[i.name].push({
                ...i,
              })
              break;
          }
        }

      })
      //展示图片
      this.exhibitionImage.list = picObject
      let isArray = [] //获取图片数组
      for (let i in picObject) {
        if (Array.isArray(picObject[i])) {
          let list = picObject[i]
          list.forEach(i => {
            if (i.PicList) {
              isArray.push(...i.PicList)
            }
          })
        }
      }
      this.exhibitionImage.arr = isArray
      let video = isArray.filter(i => i.Type != 'image' && i.type != 'image')
      this.exhibitionVideo.list = video
      //判断是否显示图片组件
      this.isShowImage = isArray.length ? true : false
      //判断是否显示video组件
      this.isShowVideo = video.length ? true : false

    },
    handleFileList(arr) {
      let picObject = {}
      //处理数据格式
      arr.map(i => {
        if (i.inputMode == 'F2') {
          switch (i.path) {
            case 'infos.insuranceFile':
            case 'infos.archive':
            case 'infos.checkReport':
              if (this.instance.hasOwnProperty(i.path)) {
                i.fileList = this.instance[i.path]
              }
              if (picObject[i.name]) {

              } else {
                picObject[i.name] = []
              }
              picObject[i.name].push({
                ...i,
              })
              break
          }
        }
      })
      //展示文件
      this.exhibitionFile.list = picObject
      let isArray = [] //获取文件数组
      for (let i in picObject) {
        if (Array.isArray(picObject[i])) {
          let list = picObject[i]
          list.forEach(i => {
            if (i.fileList) {
              isArray.push(...i.fileList)
            }
          })
        }
      }
      //判断是否显示文件组件
      this.isShowFile = isArray.length ? true : false

    },
    changeRadio(val) { //1,需采集，2，有值，3，全部
      this.handleRadios(val)
      this.currentRadio = val
    },
    formatDate(str) {
      if (str) {
        if (str.includes('-')) {
          return str
        } else {
          return str.substr(0, 4) + "-" + str.substr(4, 2) + "-" + str.substr(6, 2) + " " + str.substr(8, 2) + ":" + str.substr(10, 2) + ":" + str.substr(12, 2)
        }
      } else {
        return '--'
      }
    },
    displayData(arr) {//对数据进行处理传给组件展示
      const result = {}
      const resultEnergy = {};
      arr.map(i => {
        if (this.instance.hasOwnProperty(i.path) && this.currentRadio != 2) {
          i.value = this.instance[i.path]
        }
        if (i.inputMode == 'C5') {
          if (this.instance.hasOwnProperty(i.path)) {
            let time = this.instance[i.path]
            i.value = this.formatDate(time)
          }
        }
        if (i.dataSource && i.dataSource.length) {
          // let source = JSON.parse(i.dataSource)
          let source = i.dataSource
          //判断输入类型
          if (i.inputMode == 'D1L') {
            let d1l = tools.formatDataSource(i.dataSource)
            d1l.forEach(k => {
              if (k.code == this.instance[i.path]) {
                i.value = k.name
              }
            })
          } else if (i.inputMode == 'D2' || i.inputMode == 'C6') {
            if (this.instance.hasOwnProperty(i.path)) {
              if (!Array.isArray(this.instance[i.path])) {
                let transArray = this.instance[i.path].split(',')
                i.value = source.filter(item => transArray.includes(item.code)).map(item => item.name).join(',')
              }
            }
          }
          source.forEach(j => {
            if (j.code == this.instance[i.path]) {
              i.value = j.name
            }
          })
        }
        // 动态信息点处理
        switch (i.inputMode) {
          case "L":
          case "L1":
          case "L2":
          case "M":
            if (resultEnergy[`${i.firstName}${i.secondName ? '/' + i.secondName : ''}`]) {
              resultEnergy[`${i.firstName}${i.secondName ? '/' + i.secondName : ''}`].paths.push({
                Path: i.path,
                InfoPointName: i.name,
                InfoPointCode: i.code,
                value: i.svalue,
                Visible: i.visible,
                KeyWord: i.keyWord,
                InputMode: i.inputMode,
                data: i.data,
                receivetime: i.receivetime,
                error: i.error,
                Unit: i.unit,
                FirstName: i.firstName,
              })
            } else {
              resultEnergy[`${i.firstName}${i.secondName ? '/' + i.secondName : ''}`] = {
                paths: [{
                  Path: i.path,
                  InfoPointName: i.name,
                  InfoPointCode: i.code,
                  value: i.svalue,
                  Visible: i.visible,
                  KeyWord: i.keyWord,
                  InputMode: i.inputMode,
                  data: i.data,
                  receivetime: i.receivetime,
                  error: i.error,
                  Unit: i.unit,
                  FirstName: i.firstName,
                }]
              }
            }
            break;
          default:
            if (result[`${i.firstName}${i.secondName ? '/' + i.secondName : ''}`]) {
              result[`${i.firstName}${i.secondName ? '/' + i.secondName : ''}`].paths.push({
                Path: i.path,
                InfoPointName: i.name,
                InfoPointCode: i.code,
                Value: i.value,
                Visible: i.visible,
                KeyWord: i.keyWord,
                InputMode: i.inputMode,
                classCode: i.classCode,
                id: i.id,
                groupCode: i.groupCode,
                type: i.type
              })
            } else {
              result[`${i.firstName}${i.secondName ? '/' + i.secondName : ''}`] = {
                paths: [{
                  Path: i.path,
                  InfoPointName: i.name,
                  InfoPointCode: i.code,
                  Value: i.value,
                  Visible: i.visible,
                  KeyWord: i.keyWord,
                  InputMode: i.inputMode,
                  classCode: i.classCode,
                  id: i.id,
                  groupCode: i.groupCode,
                  type: i.type
                }]
              }
            }

        }


      })
      this.exhibitionBaseInformation.information = result
      this.exhibitionCrux.allMessage = result
      this.exhibitionEnergy.list = resultEnergy;
    },
    goBack() {
      this.$router.push({
        name: "facilityLedger",
        params: {
          deviceId: this.type
        }
      })
    },
    // 切换实例
    handleChangeExample() {
      this.selectRadio.initRadio = '1';
      this.currentRadio = '1';
      this.getData();
    },
    // 切换上一个实例
    handleClickPrev() {
      let index = this.list.findIndex(item => item.value == this.id);
      this.id = this.list[index - 1].value;
      this.handleChangeExample();
    },
    // 切换下一个实例
    handleClickNext() {
      let index = this.list.findIndex(item => item.value == this.id);
      this.id = this.list[index + 1].value;
      this.handleChangeExample();
    },
  },
  watch: {
    projectId() {
      this.$router.push({ path: "/ledger/facility" })
    }
  }
}
</script>

<style scoped lang="less">
@bgc: #fff;
.tableDisplay {
  .header {
    padding-bottom: 10px;
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;

    .details-title {
      color: #333;
      font-size: 16px;
      margin-left: 20px;
      line-height: 32px;
      cursor: pointer;
    }
  }

  .content {
    height: calc(100% - 77px);

    .content-scrollbar {
      display: flex;
      height: 100%;
      flex-direction: row;
      box-sizing: border-box;
      background-color: #f2f2f2;

      .content-left {
        display: flex;
        flex-direction: column;
        flex: 1;
        box-sizing: border-box;

        .content-keyPoint {
          border: 1px solid #ccc;
          box-sizing: border-box;
          margin-bottom: 10px;
          // overflow: hidden;
          background: @bgc;
        }

        .content-showType {
          height: 50px;
          border: 1px solid #ccc;
          border-bottom: none;
          box-sizing: border-box;
          background: @bgc;
        }

        .content-point {
          display: flex;
          flex-direction: row;
          border: 1px solid #ccc;
          box-sizing: border-box;
          background: @bgc;

          .content-point-left {
            flex: 1;
          }

          .content-point-right {
            width: 300px;
            border-left: 1px solid #ccc;
          }
        }
      }

      .content-right {
        width: 400px;
        margin-left: 10px;
        box-sizing: border-box;

        .content-repair {
          height: 50px;
          line-height: 50px;
          margin-bottom: 10px;
          border: 1px solid #ccc;
          background: @bgc;
          box-sizing: border-box;
        }

        .content-media {
          box-sizing: border-box;
        }
      }
    }
  }

  .footer {
    position: fixed;
    bottom: 0;
    left: 235px;
    width: calc(100% - 235px);
    height: 45px;
    background-color: #fff;
    box-sizing: border-box;
  }
}

/deep/ .el-scrollbar__wrap {
  overflow-x: hidden;
}

</style>
